package com.ejie.ad74a.control;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.WordUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.multipart.support.ByteArrayMultipartFileEditor;

import com.ejie.ad74a.exceptions.Ad74aException;
import com.ejie.ad74a.model.Pagos;
import com.ejie.ad74a.model.PagosBeneficiario;
import com.ejie.ad74a.model.Procesos;
import com.ejie.ad74a.service.PagosService;
import com.ejie.ad74a.service.ProcesosService;
import com.ejie.ad74a.util.comun.UtilLiterales;
import com.ejie.ad74a.util.constantes.EstadosProcesosBatchEnum;
import com.ejie.ad74a.util.constantes.MesesEnum;
import com.ejie.ad74a.util.constantes.ProcesosBatchEnum;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.json.JSONObject;
import com.ejie.x38.util.DateTimeManager;

/**
 * PagosController generated by UDA, 15-sep-2023 12:25:36.
 * 
 * @author UDA
 */

@Controller
@RequestMapping(value = "/pagos")

public class PagosController {

	private static final Logger logger = LoggerFactory.getLogger(PagosController.class);

	@Autowired
	private PagosService pagosService;

	@Autowired
	private ProcesosService procesosService;

	@Autowired
	private ReloadableResourceBundleMessageSource appMessageSource;

//	@Autowired
//	private PagosPrestadorAsyncProcessService pagosPrestadorAsyncProcessService;

	@InitBinder
	protected void initBinder(HttpServletRequest request, ServletRequestDataBinder binder) throws ServletException {
		binder.registerCustomEditor(byte[].class, new ByteArrayMultipartFileEditor());
		binder.registerCustomEditor(Date.class,
				new CustomDateEditor(DateTimeManager.getDateTimeFormat(LocaleContextHolder.getLocale()), true));
	}

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idPago74 Long
	 * @return Pagos Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idPago74}", method = RequestMethod.GET)
	public @ResponseBody Pagos get(@PathVariable Long idPago74) {
		Pagos pagos = new Pagos();
		pagos.setIdPago74(idPago74);
		pagos = this.pagosService.find(pagos);
		PagosController.logger.info("[GET - findBy_PK] : Obtener Pagos por PK");
		return pagos;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterPagos Pagos Objeto que contiene los parametros de filtrado
	 *                    utilizados en la busqueda.
	 * @return List<Pagos> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<Pagos> getAll(@ModelAttribute Pagos filterPagos) {
		PagosController.logger.info("[GET - find_ALL] : Obtener Pagos por filtro");
		return this.pagosService.findAll(filterPagos, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param pagos Pagos Bean que contiene la informacion a modificar.
	 * @return Pagos Bean resultante de la modificacion.
	 */
	@RequestMapping(value = "/edit", method = RequestMethod.PUT)
	public @ResponseBody Pagos edit(@RequestBody Pagos pagos) {
		Pagos pagosAux = this.pagosService.update(pagos);
		PagosController.logger.info("[PUT] : Pagos actualizado correctamente");
		return pagosAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param pagos Pagos Bean que contiene la informacion con la que se va a crear
	 *              el nuevo registro.
	 * @return Pagos Bean resultante del proceso de creacion.
	 */
	@RequestMapping(value = "/add", method = RequestMethod.POST)
	public @ResponseBody Pagos add(@RequestBody Pagos pagos) {
		Pagos pagosAux = this.pagosService.add(pagos);
		PagosController.logger.info("[POST] : Pagos insertado correctamente");
		return pagosAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al identificador
	 * especificado.
	 *
	 * @param idPago74 Long Identificador del objeto que se desea eliminar.
	 * @return Pagos Bean eliminado.
	 */
	@RequestMapping(value = "/{idPago74}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Pagos remove(@PathVariable Long idPago74) {
		Pagos pagos = new Pagos();
		pagos.setIdPago74(idPago74);
		this.pagosService.remove(pagos);
		PagosController.logger.info("[DELETE] : Pagos borrado correctamente");
		return pagos;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		PagosController.logger.info("[GET - View] : pagos");
		model.addAttribute("pagos", new Pagos());
		model.addAttribute("pagosBeneficiario", new PagosBeneficiario());
		Pagos pagos = this.pagosService.obtenerUltimaFechaPago();
		model.addAttribute("ultimoAnyoPago",
				pagos != null && pagos.getAnyoPago74() != null ? pagos.getAnyoPago74() : null);
		model.addAttribute("ultimoMesPago",
				pagos != null && pagos.getMesPago74() != null ? Integer.parseInt(pagos.getMesPago74()) : null);
		model.addAttribute("locale", WordUtils.capitalize(LocaleContextHolder.getLocale().toString()));
		return "pagos";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterPagos     Pagos Bean que contiene los parametros de filtrado a
	 *                        emplear.
	 * @param tableRequestDto Dto que contiene los parametros de configuracion
	 *                        propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<Pagos> Dto que contiene el resultado del filtrado
	 *         realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<Pagos> filter(@RequestJsonBody(param = "filter") Pagos filterPagos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		PagosController.logger.info("[POST - filter] : Obtener Pagoss");
		return this.pagosService.filter(filterPagos, tableRequestDto, false);
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterPagos     Pagos Bean que contiene los parametros de filtrado a
	 *                        emplear.
	 * @param searchPagos     Pagos Bean que contiene los parametros de busqueda a
	 *                        emplear.
	 * @param tableRequestDto Dto que contiene los parametros de configuracion
	 *                        propios del RUP_TABLE a aplicar en la búsqueda.
	 * @return TableRowDto<Pagos> Dto que contiene el resultado de la busqueda
	 *         realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<Pagos>> search(@RequestJsonBody(param = "filter") Pagos filterPagos,
			@RequestJsonBody(param = "search") Pagos searchPagos, @RequestJsonBody TableRequestDto tableRequestDto) {
		PagosController.logger.info("[POST - search] : Buscar Pagoss");
		return this.pagosService.search(filterPagos, searchPagos, tableRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterPagos     Pagos Bean que contiene los parametros de filtrado a
	 *                        emplear.
	 * @param tableRequestDto Dto que contiene los parametros de configuracion
	 *                        propios del RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody TableRequestDto tableRequestDto) {
		PagosController.logger.info("[POST - removeMultiple] : Eliminar multiples Pagoss");
		this.pagosService.removeMultiple(tableRequestDto);
		PagosController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los registros
	 * mediante visualizacion jerarquica.
	 * 
	 * @param filterPagos     Pagos Bean que contiene los parametros de filtrado a
	 *                        emplear.
	 * @param tableRequestDto Dto que contiene los parametros de configuracion
	 *                        propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Pagos>> Dto que contiene el resultado
	 *         del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Pagos>> jerarquia(
			@RequestJsonBody(param = "filter") Pagos filterPagos, @RequestJsonBody TableRequestDto tableRequestDto) {
		PagosController.logger.info("[POST - jerarquia] : Obtener Pagoss jerarquia");
		return this.pagosService.jerarquia(filterPagos, tableRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterPagos     Pagos Bean que contiene los parametros de filtrado a
	 *                        emplear.
	 * @param tableRequestDto Dto que contiene los parametros de configuracion
	 *                        propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Pagos>> Dto que contiene el resultado
	 *         del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Pagos>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") Pagos filterPagos, @RequestJsonBody TableRequestDto tableRequestDto) {
		PagosController.logger.info("[POST - jerarquia] : Obtener Pagoss jerarquia - Hijos");
		return this.pagosService.jerarquiaChildren(filterPagos, tableRequestDto);
	}

	/**
	 * EXPORTERS
	 */
	/**
	 * Devuelve los datos exportados de la tabla y los copia al Portapapeles.
	 *
	 * @param filterPagos     Pagos
	 * @param tableRequestDto TableRequestDto
	 */
	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	protected @ResponseBody List<Pagos> getClipboardReport(@RequestJsonBody(param = "filter") Pagos filterPagos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		PagosController.logger.info("[POST - clipboardReport] : : Copiar en Portapapeles");
		return this.pagosService.getMultiple(filterPagos, tableRequestDto, false);
	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Pagos
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = { "/xlsReport",
			"/xlsxReport" }, method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateExcelReport(@RequestJsonBody(param = "filter", required = false) Pagos filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		PagosController.logger.info("[POST - generateExcelReport] : Devuelve un fichero excel");
		tableRequestDto.setSidx("ANYOPAGO74 ,mesPago74");
		tableRequestDto.setSord("desc ,desc");
		this.pagosService.generateExcelReportPagos(filter, tableRequestDto, request, response);
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Pagos
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "pdfReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generatePDFReport(@RequestJsonBody(param = "filter", required = false) Pagos filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		PagosController.logger.info("[POST - generatePDFReport] : Devuelve un fichero pdf");

		this.pagosService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto, request,
				response);
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Pagos
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "odsReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateODSReport(@RequestJsonBody(param = "filter", required = false) Pagos filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		PagosController.logger.info("[POST - generateODSReport] : Devuelve un fichero ods");

		this.pagosService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto, request,
				response);
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Pagos
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "csvReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateCSVReport(@RequestJsonBody(param = "filter", required = false) Pagos filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		PagosController.logger.info("[POST - generateCSVReport] : Devuelve un fichero csv");

		this.pagosService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto, request,
				response);
	}

	/**
	 * Metodo para obtener las tarifas diarias y totales por territorio
	 * 
	 * @param pagos Pagos
	 * @return String Objeto JSON para pintar en pantalla
	 */
	@RequestMapping(value = "/obtenerTarifas", method = RequestMethod.POST)
	public @ResponseBody String getTarifas(@RequestBody Pagos pagos, Model model) {
		List<JSONObject> pagosTarifasTerritorio = this.pagosService.findTarifasPorTerritorio(pagos);
		List<JSONObject> pagosTarifasDiarias = this.pagosService.findTarifasDiarias(pagos);

		JSONObject result = new JSONObject();
		result.put("pagosTarifasTerritorio", pagosTarifasTerritorio);
		result.put("pagosTarifasDiarias", pagosTarifasDiarias);

		PagosController.logger.info("[POST - getTarifas] : Obtener Tarifas diarias y totales por territorio");
		return result.toString();
	}

	/**
	 * Metodo para añadir un nuevo pago.
	 *
	 * @param pagos Pagos Bean que contiene la informacion con la que se va a crear
	 *              el nuevo registro.
	 * @return Pagos Bean resultante del proceso de creacion.
	 */
	@PostMapping(value = "/anadirpago")
	public @ResponseBody Procesos anadirPago(@RequestBody Pagos pagos, HttpServletRequest request) {

		// 1.- Comprobar si ya existe un proceso de añadir o recalcular sin finalizar
		Procesos proceso = new Procesos();
//		proceso.setTipoProceso98(ProcesosBatchEnum.ANADIR_PAGO_PRESTADOR.getId());
//		proceso.setProceso98(pagos.getAnyoPago74() + "_" + pagos.getMesPago74());
		List<Integer> tiposProcesoFilter = new ArrayList<Integer>();
		tiposProcesoFilter.add(ProcesosBatchEnum.ANADIR_PAGO_PRESTADOR.getId());
		tiposProcesoFilter.add(ProcesosBatchEnum.RECALCULAR_PAGO_PRESTADOR.getId());
		proceso.setTiposProcesoFilter(tiposProcesoFilter);

		List<String> estadosFilter = new ArrayList<String>();
		estadosFilter.add(EstadosProcesosBatchEnum.PENDIENTE.getId());
		estadosFilter.add(EstadosProcesosBatchEnum.INICIADO.getId());
		proceso.setEstadosFilter(estadosFilter);

		List<Procesos> procesosList = this.procesosService.findAllLike(proceso, null, false);
		if (!procesosList.isEmpty()) {
			// TODO: devolver error. Ver como se está haciendo en otras llamadas
			// TODO: internacionalizar mensaje
			throw new Ad74aException(
					UtilLiterales.getLiteralMessage(appMessageSource, "pagos.error.procesoEnEjecucion"));
		}

		// 2.- Comprobar que no existe un pago para el año y mes seleccinado
		List<Pagos> pagosList = this.pagosService.findAllLike(pagos, null, false);
		if (!pagosList.isEmpty()) {
			// TODO: devolver error. Ver como se está haciendo en otras llamadas
			// TODO: internacionalizar mensaje
			String[] params = { MesesEnum.getLabelDesc(pagos.getMesPago74()).toLowerCase(),
					pagos.getAnyoPago74().toString() };
			throw new Ad74aException(
					UtilLiterales.getLiteralMessageWithParams(appMessageSource, "pagos.error.pagoExiste", params));
		}

		proceso = this.pagosService.anadirPago(pagos, request);
		PagosController.logger.info("[POST] : anadirPago correctamente");
		return proceso;
	}

	/**
	 * Metodo para añadir un nuevo pago.
	 *
	 * @param pagos Pagos Bean que contiene la informacion con la que se va a crear
	 *              el nuevo registro.
	 * @return Pagos Bean resultante del proceso de creacion.
	 */
	@PostMapping(value = "/recalcular/{idPago74}")
	public @ResponseBody Procesos recalcularPago(@PathVariable Long idPago74, HttpServletRequest request) {

		Pagos pago = new Pagos(idPago74);
		// Comprobar si ya existe un proceso igual sin finalizar
		Procesos proceso = new Procesos();
//		proceso.setTipoProceso98(ProcesosBatchEnum.RECALCULAR_PAGO_PRESTADOR.getId());
//		proceso.setProceso98(idPago74.toString());
		List<Integer> tiposProcesoFilter = new ArrayList<Integer>();
		tiposProcesoFilter.add(ProcesosBatchEnum.ANADIR_PAGO_PRESTADOR.getId());
		tiposProcesoFilter.add(ProcesosBatchEnum.RECALCULAR_PAGO_PRESTADOR.getId());
		proceso.setTiposProcesoFilter(tiposProcesoFilter);

		List<String> estadosFilter = new ArrayList<String>();
		estadosFilter.add(EstadosProcesosBatchEnum.PENDIENTE.getId());
		estadosFilter.add(EstadosProcesosBatchEnum.INICIADO.getId());
		proceso.setEstadosFilter(estadosFilter);

		List<Procesos> procesosList = this.procesosService.findAllLike(proceso, null, null);
		if (!procesosList.isEmpty()) {
			// TODO: devolver error. Ver como se está haciendo en otras llamadas
			// TODO: internacionalizar mensaje
			throw new Ad74aException("Ya existe un proceso en ejecución para añadir o recalcular un pago");
		}

		proceso = this.pagosService.recalcularPago(pago, request);

		PagosController.logger.info("[POST] : recalcularPago correctamente");
		return proceso;
	}

}
